=begin rdoc
= Random Painter no WxSU
Copyright 2009, Chris Fullmer
All Rights Reserved

== Disclaimer
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

== License
Copyright 2009, Chris Fullmer
You may not alter, publish, market, distribute, give, transfer, sell or sublicense the Scripts or any part of this Script.

== Information
Author:: Chris Fullmer
Organization:: Chrisfullmer.com
Name:: Random Painter no WxSU
Version:: 1.1 no WxSU 
SU Version:: 5?
Date:: Mar 21, 2009
Description:: This script will take the selection and paint it random colors that the user inputs
Usage:: Select the items to be painted.  Run the script from the Plugins>Chris Fullmer Tools> Menu.  Then type in RGB values (0-255).  When done inputing colors, just click ok without entering any colors.  Then it will randomly apply the colors to all faces.  It does not apply colors to edges.
History::
0.1:: 2009-02-07
   * First release
1.1 No WxSU:: 2009-03-21
   * This is not really a new release.  Its gone backwards in its features.  It does not support WxSU for people who are having problems with WxSU.
=end

require "sketchup.rb"

# Wrapping the whole script into a module with a very unique name so as to not let any of my
# methods or variables interefere with anyone else's scripts.
module Clf_painter
	def Clf_painter.rand_painter
		
		#Sets the selection for this ruby to whatever is currently selected
		model = Sketchup.active_model
		clselection = model.selection
		#If nothing is selected, then it returns an message to select something first
		if clselection.empty?
		    UI.messagebox "Please select the faces to be painted first"
		    resturn
		end
		
		# Initialize a couple of arrays and a variable for use later
		results = []
		color = []
		count = 0
		
		# Starts the Inputbox and makes it keep popping up until no values are entered
		while results != ["", "", ""]
			prompts = ["R:", "G:", "B:"]
			values = []
			results = inputbox( prompts, values )
			color.push results
		end
		
		#Removes the empty array created when the user hits "ok" on the blank inputbox
		color.pop
		
		# Decides what version of SU is being run and then begins the group of operatiosn for the undo command.  Uses the
		#fast code (true) if using version 7.
		a = Sketchup.version
		b = a[0,1].to_i
		if b > 6
			model.start_operation("Random Color", true)
		else
			model.start_operation("Random Color")
		end
		
		# This takes the selection and runs through each entity selected and decides if it is a face.  
		# If it is a face, then one of the colors previously input by the user gets applied to it.
		clselection.each do
			clent = clselection[count]
		  	if clent.typename == ("Face")
				rand_col = rand(color.length).to_i
				puts color[rand_col].to_a
				paintcolor = color[rand_col]
				clent.material = [paintcolor[0].to_i, paintcolor[1].to_i, paintcolor[2].to_i]
				clent.back_material=[paintcolor[0].to_i, paintcolor[1].to_i, paintcolor[2].to_i]
			end
			count = count + 1
		end
		
		# This closes the undo stack.  Everything between the start and commit are looked at as a single undo command.
		model.commit_operation
		Sketchup.send_action "selectSelectionTool:"
	end
end

if( $submenu )
	organizer = $submenu 
	if !file_loaded?(__FILE__) then
		organizer.add_item("Random Painter no WxSU") { Sketchup.active_model.select_tool Clf_painter.rand_painter }
	end
else
	if !file_loaded?('clf_menu_loader') then
		$clf_tools_menu = UI.menu("Plugins").add_submenu("Chris Fullmer Tools")
	end
	if !file_loaded?(__FILE__) then
		$clf_tools_menu.add_item("Random Painter no WxSU") { Sketchup.active_model.select_tool Clf_painter.rand_painter }
	end
end

file_loaded('clf_menu_loader')
file_loaded(__FILE__)
